{$A+,B-,D-,E+,F-,I-,L-,N-,O-,R-,S-,V-}
{$M 65520,0,655360}
Program MINES_1;
Uses Crt,Dos,SuperV;
 Const
   Atrib:array [0..15] of byte = ($2f,$3f,$3f,$3f,$3f,$3f,$3f,$3f,$3f,$2f,$1e,$4e,$4c,$8f,$97,$cf);

 type
   map	=  array[0..15,0..15] of byte;

 label labm1,labm2,labm3;
 var
   Timer	:	longint absolute $0:$046c;
   MyTimer,Score	:	Word;
   OldTimer	:	longint;
   MainMap	:	map;
   GameMap	:	map;
   MySteck	:	array [0..255] of byte;
   Start,Flag	:	boolean;
   A,B,C,D,X,Y,XM,YM	:	byte;
   Mines		:	byte;
   Simbols	:	string;
   Key		:	Char;


 Procedure TitleProg;
   begin
     SWindow(216,20,7,58,17,15,1,15,14,'',' Press any key ');
     Writeln;
     Writeln('        M I N E S W I P P E R');
     Writeln;
     WriteLn('            Version  1.05');
     Writeln;
     WriteLn('        (c)1992 Arum Software');
     Writeln;
     Writeln('     Author  Boychenko Alexander');
     pause;
     CloseWin;
   end;

 Procedure To_Dos;
 label labe1,labe2;
 var
   a	:	byte;

   begin
     swindow(220,21,11,55,14,14,5,0,15,' Exit to Dos ',' Esc - return in MINES ');
     {textcolor(4);}
     writeln('        Are  You  Sure  ?');
     Write  ('       Yes             N O');
     InitBCur(17,1,128,0,'  '+#0+#31);
     a:=22;
     BCur(a,13);
     while key<#255 do
       begin
         Key:=ReadKey;
         if key=#0 then
           begin
             key:=readkey;
             if key=#75 then a:=22;
             if key=#77 then a:=38;
             BCur(a,13);
           end;
         if key in ['Y','y'] then
           begin
labe1:       KillBCur;
             CloseWin;
             CloseWin;
             CloseWin;
             CloseWin;
             Halt;
           end;
         if key in ['N','n',#27] then
           begin
labe2:       KillBCur;
             CloseWin;
             exit;
           end;
         if key in [' ',#13] then
                               if a=22 then goto labe1
                                       else goto labe2;
       end;
   end;

 Procedure CheckPos;
   begin
     if y>16 then y:=16;
     if y<1 then y:=1;
     if x<2 then x:=2;
     if x>32 then x:=32;
   end;

 Procedure PrintMin;
 var
   s		:	string;
 begin
   Str(Mines:2,s);
   WriteStr(65,4,$70,s);
 end;

 Procedure PrintTime;
 var s		:	string;
 begin
   MyTimer:=(timer-oldtimer) div 19;
   Str(MyTimer:4,s);
   WriteStr(63,5,$70,s);
 end;

 Function LookPos(X1,Y1:byte):byte;
 label lab1;
 var
   a,b		:	byte;
   i,j		:	byte;
   x,y		:	shortint;
   xy		:	byte;
   begin
     a:=MainMap[x1,y1];
     b:=GameMap[x1,y1];
     LookPos:=0;
     if (b=11) or (b=12) then exit;
     GameMap[x1,y1]:=a;
     if a=13 then begin LookPos:=2;exit;end;
     if a=0 then
       begin
         LookPos:=1;
         i:=1;
         MySteck[0]:=(y1 shl 4) or x1;
         while i>0 do
           begin
             i:=i-1;
             a:=MySteck[i];
             x1:=a and 15;
             y1:=a shr 4;
             for y:=y1-1 to y1+1 do
               begin
                 for x:=x1-1 to x1+1 do
                   begin
                     if ((x<0) or (x>15) or (y<0) or (y>15)) then goto lab1;
                     a:=MainMap[x,y];
                     b:=GameMap[x,y];
                     GameMap[x,y]:=a;
                     if ((a=0) and (b=10)) then
                       begin
                         xy:=(y shl 4) or x;
                         for j:=0 to i do
                           begin
                             b:=MySteck[j];
                             if b=xy then goto lab1;
                           end;
                         MySteck[i]:=xy;
                         inc(i);
                       end;
lab1:              end;
               end;
           end;
       end;
   end;



 Procedure SetMines;
  var
   b,c,z	:	byte;
   a,d,x,y	:	shortint;

   begin
   a:=0;
   d:=0;
   c:=0;
   while c<40 do
     begin
       b:=random(16);
       if (b=13) and (MainMap[a,d]=0) then
         begin
           MainMap[a,d]:=b;
           inc(c);
         end;
       inc(a);
       if a>15 then
         begin
           a:=0;
           inc(d);
           if d>15 then d:=0;
         end;
     end;
   for  a:=0 to 15 do
     for d:=0 to 15 do
       begin
         if MainMap[a,d]=0 then
           begin
             b:=0;
             for x:=a-1 to a+1 do
               for y:=d-1 to d+1 do
                 begin
                   if ((x>=0) and (x<16) and (y>=0) and (y<16)) then
                       if MainMap[x,y]=13 then z:=1
                          else z:=0
                     else z:=0;
                   b:=b+z;
                 end;
             MainMap[a,d]:=b;
           end;
       end;
 end;

 Procedure PutPos(x,y:byte);
 var
 a		:	byte;
   begin
     a:=GameMap[x,y];
     x:=(x shl 1)+11;
     y:=y+4;
     WriteChr(x,y,Atrib[a],Simbols[a*2+1]);
     WriteChr(x+1,y,Atrib[a],Simbols[a*2+2]);
   end;



 Procedure PutMap(M:map);   			                  {  뢥   }
 var
   x,y,c	:	byte;
   begin
     for y:=0 to 15 do
       for x:=0 to 15 do
         begin
           c:=M[x,y];
           WriteChr(x*2+11,y+4,Atrib[c],Simbols[c*2+1]);
           WriteChr(x*2+12,y+4,Atrib[c],Simbols[c*2+2]);
         end;
   end;                                                  { End of PutMap }

 Procedure GameOver;
  var
    a,b,c,d,m	:	byte;

   begin
     SWindow(216,47,9,68,13,15,1,15,14,' Game  Over ',' Enter to ReStart ');
     m:=0;
     for a:=0 to 15 do
       for b:=0 to 15 do
         begin
           c:=GameMap[b,a];
           d:=MainMap[b,a];
           if ((c=11) and (d=13)) then
             begin
               inc(m);
               c:=15;
             end;
           if ((c=10) and (d=13)) then
             begin
               GameMap[b,a]:=d;
             end;
           if ((c=11) and (d<13)) then
             begin
               c:=14;
             end;
           GameMap[b,a]:=c;
         end;
     WriteLn(' Found   ',m:2,' mines. ');
     Writeln(' Bonus        ',m*1000:5);
     MyTimer:=(timer-oldtimer) div 19;
     Score:=0;
     if MyTimer>0 then
       Score:=(m*1000)*(600 div MyTimer);
     Write  (' Score       ',Score:6);
     PutMap(GameMap);
     Flag:=true;
     While flag do
       begin
         Key:=ReadKey;
         if key=#0 then key:=ReadKey;
         if key in [#13,#32] then
           begin
             Start:=true;
             Flag:=false;
           end;
         if key=#27 then
           begin
             To_Dos;
             {Start:=false;
             Flag:=false;}
           end;
       end;
       CloseWin;
       CloseWin;
       CloseWin;
   end;

 begin
   ClrScr;
   randomize;
   Simbols:=' . 1 2 3 4 5 6 7 8 9   # ? * * +';
   TitleProg;
labm1:
   SWindow(216,47,3,68,6,0,7,0,0,'','');
   writeln(' Exist mines :   40');
   Write  (' Time        :    1');
   SWindow(216,10,3,43,20,0,7,0,0,' M  I  N  E  S ','Esc to exit');
   Mines:=40;
   for y:=4 to 19 do
     for x:=11 to 42 do
       writechr(x,y,$70,' ');
   fillchar(MainMap,256,#0);
   fillchar(GameMap,256,#10);
   SetMines;
   PutMap(GameMap);
   OldTimer:=timer;
   x:=2;y:=1;
   gotoxy(x,y);
   Key:=#1;
   Start:=false;
   While Key<#255 do
     begin
       PrintTime;
       if Mines=0 then
         begin
           GameOver;
           if Start then goto labm1 else To_Dos;
         end;
       if keypressed then
           begin
             key:=readkey;
             if key=#0 then
               begin
                 key:=readkey;
                 if key=#80 then
                              begin
                                y:=y+1;
                                CheckPos;
                              end;
                 if key=#72 then
                              begin
                                y:=y-1;
                                CheckPos;
                              end;
                 if key=#75 then
                              begin
                                x:=x-2;
                                CheckPos;
                              end;
                 if key=#77 then
                              begin
                                x:=x+2;
                                CheckPos;
                              end;
                 if key=#71 then
                              begin
                                x:=x-2;
                                y:=y-1;
                                CheckPos;
                              end;
                 if key=#79 then
                              begin
                                x:=x-2;
                                y:=y+1;
                                CheckPos;
                              end;
                 if key=#73 then
                              begin
                                x:=x+2;
                                y:=y-1;
                                CheckPos;
                              end;
                 if key=#81 then
                              begin
                                x:=x+2;
                                y:=y+1;
                                CheckPos;
                              end;
                 if key=#82 then goto labm2;
                 if key=#83 then goto labm3;
                 gotoxy(x,y);
                 key:=#1;
               end;
             if key=#13 then
                         begin
labm2:                     xm:=x div 2-1;
                           ym:=y-1;
                           a:=LookPos(xm,ym);
                           if a=2 then
                             Begin
                               GameOver;
                               if Start then goto labm1 else To_Dos;
                             end;
                           if a=1 then PutMap(GameMap) else PutPos(xm,ym);
                         end;
             if key=#32 then
                         begin
labm3:                     xm:=x div 2-1;
                           ym:=y-1;
                           a:=GameMap[xm,ym];
                           if a=10 then
                             begin
                               a:=11;
                               Dec(Mines);
                             end
                             else
                               if a=11 then
                                 begin
                                   a:=12;
                                   Inc(Mines);
                                 end
                                 else
                                   if a=12 then a:=10;
                           GameMap[xm,ym]:=a;
                           PutPos(xm,ym);
                           PrintMin;
                         end;
                if key=#27 then
                  begin
                    GameOver;
                    if Start then goto Labm1 else To_Dos;
                  end;
           end;
         end;
 end.


